
int inputPin = 6;           //input pin)

#include"LEDpat.h"
//
int* pata[7]={pat1,pat2,pat3,pat4,pat5,pat6,pat7};
int poi[7];
boolean state[7]; 
int msCount[7];

unsigned long tickMicrosecond = 0;
unsigned long startedMicrosecond = 0;
unsigned long countupMicrosecond = 0;
unsigned long blinkSpeed = 1000;

void setup()
{
  int i;
  for (i = 7; i <= 13; i++) {  // ピン番号
    pinMode(i, OUTPUT);        // アウトプットに設定
  }

  pinMode(inputPin, INPUT); 
  digitalWrite(inputPin, HIGH);   //　内蔵プルアップ有効
}

void loop()
{
  unsigned long now = micros();
  unsigned long elapsedMicroceconds;//

  if(digitalRead(inputPin) == LOW){ 
    elapsedMicroceconds = now - tickMicrosecond;  
    if(elapsedMicroceconds > 10000)
    {
      int i;
      for (i = 7; i <= 13; i++) {
        int n= i-7;
        digitalWrite(i, LOW);
        state[n] = false;
        poi[n] = 0;
        msCount[n] = 0;
      }
      
//      if(elapsedMicroceconds <110000){//早く動かしたとき
//        blinkSpeed = 900;
//      }else if(elapsedMicroceconds < 150000){//ゆっくり
//        blinkSpeed = 1500;
//      }
      blinkSpeed = 900;
      
      startedMicrosecond = now;
      countupMicrosecond = now;
    }
    tickMicrosecond = now;
  }

  now = micros();
  if(startedMicrosecond !=0){
    if(now - countupMicrosecond > blinkSpeed){
      
      for(int pin=7;pin<=13;pin++)
      {
        int n = pin-7;
        int* pat = pata[n];
        
        if(pat[poi[n]] == -1){
          ;
        }
        else if(pat[poi[n]] <= msCount[n]){
          if(state[n]){ 
            digitalWrite(pin,LOW);
            state[n] = false;
          }
          else{
            digitalWrite(pin,HIGH);
            state[n]=true;
          }
          poi[n]++;
          msCount[n] = 0;
        }  
        msCount[n]++;
      }
      countupMicrosecond = now;
    }
  }
  if(startedMicrosecond != 0 && now - startedMicrosecond > 500000){
    startedMicrosecond = 0;
    int i;
    for (i = 7; i <= 13; i++) {
      digitalWrite(i, LOW);
    }
  }
}






